.686p
.model flat, stdcall
option casemap:none
	
	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\gdi32.inc
	include \masm32\macros\Strings.mac
	
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\gdi32.lib

	m2m macro M1, M2
		push M2
		pop  M1
	endm
	
	IDD_ABOUT		equ	101
	
	DlgProc			proto	:HWND, :UINT, :LPARAM, :WPARAM
	_rand			proto	:DWORD
	range_rand		proto	:DWORD, :DWORD
	gen_palette		proto
	init_meta		proto	:HWND
	uninit_meta		proto	:HWND
	move_balls		proto
	process_meta	proto
	print_text		proto
	render_meta		proto
	ZeroMemory		proto	:DWORD, :DWORD

	METABALL struct
		_x		UINT	?
		_y		UINT	?
		_dx		UINT	?
		_dy		UINT	?
		mass	DWORD	?
		v_ttl	DWORD	?
	METABALL ends
	PMETABALL	typedef ptr METABALL
	
	rgb	struct
		r		BYTE	?
		g		BYTE	?
		b		BYTE	?
		foo		BYTE	?
	rgb ends
	Prgb	typedef ptr rgb
	
.const
	MIN_D		equ	2
	MAX_D		equ	10
	
	MIN_BALLS	equ	3
	MAX_BALLS	equ	6
	
	MIN_MASS	equ	20
	MAX_MASS	equ	100
	
	MIN_VTTL	equ	20
	MAX_VTTL	equ	70
	
	WX			equ	278 ; 
	WY			equ 220 ; 
	
	WM_TIMER_DRAW	equ	1
	WM_TIMER_MOVE	equ	2
	
.data
	szOffset		dd	offset	szText
	szText			db	'the Power Of Reversing team', 0
					db	'          present', 0
					db	'  about template for your', 13
					db	'      cracks or tools', 0
					db	'Greetings fly out to:', 13, 13
					db	'  Rustem for C++ source', 13
					db	'  Asterix and Quantum 4 uFMOD', 0
					db	'masm32 sources by void //tPORt', 0 
					db	0
					
	TxtAddColValue	BYTE	0
	TxtNewColor		BYTE	0
		
.data?
	hInstance		HINSTANCE	?
	
	;pal				Prgb		<?>
	;balls			PMETABALL	<?>
	
	balls_cnt		dd		?
	seed			dd		?
	X_SIZE			dd		?
	Y_SIZE			dd		?
	hFont			HFONT		?
	
	hDIBSec			HBITMAP		?
	hMemDC			HDC			?
	pdata			PVOID		?
	hOld1			HGDIOBJ		?
	hOld2			HGDIOBJ		?
	
	SD				DWORD		? ; Show Delay
	DY				DWORD		? ; Delta Y
	
;	include music.asm

.code
start:
	invoke GetModuleHandle, NULL
	mov hInstance, eax	
	invoke DialogBoxParam, hInstance, IDD_ABOUT, 0, offset DlgProc, 0
	invoke ExitProcess, NULL

;--------------------------------------------------------------------------------

ZeroMemory proc uses edi lpMem, Len: DWORD
		cld
		mov edi, lpMem
		mov ecx, Len
		shr ecx, 2
		xor eax, eax
		jecxz @F
		rep stosd
	@@:
		mov ecx, Len
		and ecx, 3
		jecxz @F
		rep stosb
	@@:
		ret
ZeroMemory endp

;--------------------------------------------------------------------------------

UpdateWordsColor proc

	mov al, TxtNewColor
	.if al == 255
		mov TxtAddColValue, -1
	.elseif al == 0
		mov TxtAddColValue, 1
	.endif
	add al, TxtAddColValue	
	mov TxtNewColor, al
	ret
UpdateWordsColor endp

RGB proc r_:BYTE, g_:BYTE, b_:BYTE
	movzx eax, b_
	shl eax, 8
	mov al, g_
	shl eax, 8
	mov al, r_
	;Result := (r or (g shl 8) or (b shl 16));
	ret
RGB endp

;--------------------------------------------------------------------------------

_srand	macro
	xor eax, eax
	rdtsc
	mov seed, eax
endm

;--------------------------------------------------------------------------------

_rand	proc	r: DWORD
	
	mov eax, seed
	imul eax, 343FDh
	mov seed, eax
	mov ecx, seed
	add ecx, 269EC3h
	mov seed, ecx
	mov eax, seed
	shr eax, 10h
	and eax, 7FFFh
	xor edx, edx
	div r
	mov eax, edx
	ret
_rand endp
	
;--------------------------------------------------------------------------------

range_rand	proc	min: DWORD, max: DWORD
	
	mov eax, min
	.if eax == max
		mov eax, min
		ret
	.endif
	
	mov ecx, max
	sub ecx, min
	invoke _rand, ecx
	mov edx, min
	add eax, edx
	ret
range_rand endp

;--------------------------------------------------------------------------------

gen_palette	proc
LOCAL j:	DWORD
LOCAL i:	DWORD
LOCAL idx:	DWORD
LOCAL b_:	BYTE
LOCAL g_:	BYTE
LOCAL r_:	BYTE
	
	mov r_, 0
	mov g_, 0
	mov b_, 0
	mov idx, 0
	
	invoke VirtualAlloc, 0, 256 * SizeOf(rgb), MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE
	mov pal, eax
	
	mov j, 0
	.while j < 256
		mov ecx, j
		mov edx, pal
		mov byte ptr [edx + ecx * 4], 0FCh
		
		mov eax, j
		mov ecx, pal
		mov byte ptr [ecx + eax * 4 + 1], 0FCh
		
		mov edx, j
		mov eax, pal
		mov byte ptr [eax + edx * 4 + 2], 0FCh
		
		mov eax, j
		add eax, 1
		mov j, eax
	.endw
	
	mov j, 0
	.while j < 3

		mov i, 4
		.while i <= 0FCh

			.if j == 0
				mov al, byte ptr [i]
				mov r_, al
			.elseif j == 1
				mov r_, 0FCh
				mov cl, byte ptr [i]
				mov g_, cl
			.elseif j == 2
				mov r_, 0FCh
				mov g_, 0FCh
				mov dl, byte ptr [i]
				mov b_, dl
			.endif

			mov eax, idx
			mov ecx, pal
			mov dl, r_
			mov [ecx + eax * 4], dl
			
			mov eax, idx
			mov ecx, pal
			mov dl, g_
			mov [ecx + eax * 4 + 1], dl
			
			mov eax, idx
			mov ecx, pal
			mov dl, b_
			mov [ecx + eax * 4 + 2], dl
			
			mov eax, idx
			add eax, 1
			mov idx, eax
			
			mov edx, i
			add edx, 4
			mov i, edx
		.endw
		
		mov ecx, j
		add ecx, 1
		mov j, ecx
	.endw
	
	mov eax, pal
	ret
gen_palette endp

;--------------------------------------------------------------------------------

init_meta	proc	hWnd: HWND
LOCAL lf: LOGFONT
LOCAL bi: BITMAPINFO
LOCAL rc: RECT
LOCAL k: DWORD
	
	invoke ZeroMemory, addr bi, SizeOf(BITMAPINFO)
	invoke ZeroMemory, addr lf, SizeOf(LOGFONT)
	mov lf.lfHeight, 16
	invoke lstrcpy, addr lf.lfFaceName, $CT0('Courier New')
	invoke CreateFontIndirect, addr lf
	mov hFont, eax
	invoke GetWindowRect, hWnd, addr rc
	
	mov edx, rc.right
	sub edx, rc.left
	mov X_SIZE, edx

	mov eax, rc.bottom
	sub eax, rc.top
	mov Y_SIZE, eax
	
	_srand
	
	invoke gen_palette
	mov pal, eax
	
	invoke range_rand, MIN_BALLS, MAX_BALLS
	mov balls_cnt, eax
	
	imul eax, SizeOf(METABALL)
	invoke VirtualAlloc, 0, eax, MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE
	mov balls, eax
	
	mov k, 0
	mov eax, k
	.while eax < balls_cnt
		mov k, eax
		
		invoke range_rand, 0, X_SIZE
		mov edx, k
		imul edx, 18h
		mov ecx, balls
		mov [ecx + edx], eax
		
		invoke range_rand, 0, Y_SIZE
		mov ecx, k
		imul ecx, 18h
		mov edx, balls
		mov [edx + ecx + 4], eax
		
		invoke range_rand, MIN_MASS, MAX_MASS
		imul eax, 10000
		mov ecx, k
		imul ecx, 18h
		mov edx, balls
		mov [edx + ecx + 10h], eax
		
		invoke _rand, 2
		.if !eax
			invoke range_rand, MIN_D, MAX_D
			mov ecx, k
			imul ecx, 18h
			mov edx, balls
			mov [edx + ecx + 8], eax
		.else
			invoke range_rand, MIN_D, MAX_D
			neg eax
			mov ecx, k
			imul ecx, 18h
			mov edx, balls
			mov [edx + ecx + 8], eax
		.endif
		
		invoke _rand, 2
		.if !eax
			invoke range_rand, MIN_D, MAX_D
			mov ecx, k
			imul ecx, 18h
			mov edx, balls
			mov [edx + ecx + 0Ch], eax
		.else
			invoke range_rand, MIN_D, MAX_D
			neg eax
			mov ecx, k
			imul ecx, 18h
			mov edx, balls
			mov [edx + ecx + 0Ch], eax
		.endif
		
		invoke range_rand, MIN_VTTL, MAX_VTTL
		mov ecx, k
		imul ecx, 18h
		mov edx, balls
		mov [edx + ecx + 14h], eax
		
		mov eax, k
		add eax, 1
		mov k, eax
	.endw
	
	invoke SetTimer, hWnd, WM_TIMER_DRAW, 25, NULL
	invoke SetTimer, hWnd, WM_TIMER_MOVE, 1, NULL
	mov bi.bmiHeader.biSize, SizeOf(BITMAPINFOHEADER)
	mov ecx, X_SIZE
	mov bi.bmiHeader.biWidth, ecx
	mov edx, Y_SIZE
	mov bi.bmiHeader.biHeight, edx
	mov bi.bmiHeader.biPlanes, 1
	mov bi.bmiHeader.biBitCount, 32
	mov bi.bmiHeader.biCompression, BI_RGB
	invoke CreateCompatibleDC, 0
	mov hMemDC, eax
	invoke CreateDIBSection, hMemDC, addr bi, DIB_RGB_COLORS, addr pdata, 0, 0
	mov hDIBSec, eax
	invoke SelectObject, hMemDC, hDIBSec
	mov hOld1, eax
	invoke SelectObject, hMemDC, hFont
	mov hOld2, eax
	invoke SetBkMode, hMemDC, TRANSPARENT

	;invoke RGB, TxtNewColor, 50, 50
	;invoke SetTextColor, hMemDC, eax
	ret
init_meta endp

;--------------------------------------------------------------------------------

uninit_meta	proc	hWnd: HWND
	
	invoke VirtualFree, addr pal, 0, MEM_RELEASE
	invoke VirtualFree, addr balls, 0, MEM_RELEASE
	invoke KillTimer, hWnd, 1
	invoke SelectObject, hMemDC, hOld2
	invoke DeleteObject, hFont
	invoke SelectObject, hMemDC, hOld1
	invoke DeleteObject, hDIBSec
	invoke DeleteDC, hMemDC
	ret
uninit_meta endp

;--------------------------------------------------------------------------------

move_balls	proc
LOCAL k: DWORD
	
	mov k, 0
	mov ecx, k
	.while ecx < balls_cnt
		
		mov edx, k
		imul edx, 18h
		mov eax, k
		imul eax, 18h
		mov ecx, balls
		mov edx, [ecx + edx]
		mov ecx, balls
		add edx, [ecx + eax + 8]
		mov eax, k
		imul eax, 18h
		mov ecx, balls
		mov [ecx + eax], edx
		
		mov edx, k
		imul edx, 18h
		mov eax, k
		imul eax, 18h
		mov ecx, balls
		mov edx, [ecx + edx + 4]
		mov ecx, balls
		add edx, [ecx + eax + 0Ch]
		mov eax, k
		imul eax, 18h
		mov ecx, balls
		mov [ecx + eax + 4], edx
		
		mov edx, k
		imul edx, 18h
		mov eax, balls

		cmp dword ptr [eax + edx], 0
		jge @F
			mov	ecx, k
			imul ecx, 18h
			mov	edx, balls
			mov	dword ptr [edx + ecx], 0
			
			invoke range_rand, MIN_D, MAX_D
			mov	ecx, k
			imul ecx, 18h
			mov	edx, balls
			mov	[edx + ecx + 8], eax
		@@:
		
		mov	eax, k
		imul eax, 18h
		mov	ecx, balls
		mov	edx, [ecx + eax]
		
		.if edx > X_SIZE
			mov eax, k
			imul eax, 18h
			mov ecx, balls
			mov edx, X_SIZE
			mov [ecx + eax], edx
			
			invoke range_rand, MIN_D, MAX_D
			neg	eax
			mov	ecx, k
			imul ecx, 18h
			mov	edx, balls
			mov	[edx + ecx + 8], eax
		.endif
		
		mov	eax, k
		imul eax, 18h
		mov	ecx, balls
		
		cmp dword ptr [ecx + eax + 4], 0
		jge @F
			mov	edx, k
			imul edx, 18h
			mov	eax, balls
			mov	dword ptr [eax + edx + 4], 0
			
			invoke range_rand, MIN_D, MAX_D
			mov	ecx, k
			imul ecx, 18h
			mov	edx, balls
			mov	[edx + ecx + 0Ch], eax
		@@:
		
		mov	eax, k
		imul eax, 18h
		mov	ecx, balls
		mov	edx, [ecx + eax + 4]
		
		.if edx > Y_SIZE
			mov	eax, k
			imul eax, 18h
			mov	ecx, balls
			mov	edx, Y_SIZE
			mov	[ecx + eax + 4], edx
			
			invoke range_rand, MIN_D, MAX_D
			neg eax
			mov	ecx, k
			imul ecx, 18h
			mov	edx, balls
			mov	[edx + ecx + 0Ch], eax
		.endif
		 
		mov	eax, k
		imul eax, 18h
		mov	ecx, balls
		
		.if dword ptr [ecx + eax + 14h] != 0
			mov	edx, k
			imul edx, 18h
			mov	eax, balls
			mov	ecx, [eax + edx + 14h]
			sub	ecx, 1
			mov	edx, k
			imul edx, 18h
			mov	eax, balls
			mov	[eax + edx + 14h], ecx
		.else
			invoke range_rand, MIN_VTTL, MAX_VTTL
			mov	ecx, k
			imul ecx, 18h
			mov	edx, balls
			mov	[edx + ecx + 14h], eax
			
			invoke _rand, 2
			.if !eax
				invoke range_rand, MIN_D, MAX_D
				mov	ecx, k
				imul ecx, 18h
				mov	edx, balls
				mov	[edx + ecx + 8], eax
			.else
				invoke range_rand, MIN_D, MAX_D
				neg	eax
				mov	ecx, k
				imul ecx, 18h
				mov	edx, balls
				mov	[edx + ecx + 8], eax
			.endif
			
			invoke _rand, 2
			.if !eax
				
				invoke range_rand, MIN_D, MAX_D
				mov	ecx, k
				imul ecx, 18h
				mov	edx, balls
				mov	[edx + ecx + 0Ch], eax
			.else
				invoke range_rand, MIN_D, MAX_D
				neg	eax
				mov	ecx, k
				imul ecx, 18h
				mov	edx, balls
				mov	[edx + ecx + 0Ch], eax
			.endif
		.endif
		
		mov ecx, k
		add ecx, 1
		mov k, ecx
	.endw
	ret
move_balls endp

;-------------------------------------------------------------------------------

process_meta	proc
LOCAL b: RGBQUAD
LOCAL c_: DWORD
LOCAL cc: DWORD
LOCAL d: DWORD
LOCAL k: DWORD
LOCAL yn: DWORD
LOCAL xn: DWORD
	
	mov eax, pdata
	mov b, eax
	
	mov yn, 0
	mov edx, yn
	.while edx < Y_SIZE
		mov yn, edx
		
		mov xn, 0
		mov ecx, xn
		.while ecx < X_SIZE
			mov xn, ecx
			
			mov c_, 0
			
			mov k, 0
			mov eax, k
			.while eax < balls_cnt
				mov k, eax
				
				mov ecx, k
				imul ecx, 18h
				mov edx, balls
				mov eax, [edx + ecx]
				sub eax, xn
				mov ecx, k
				imul ecx, 18h
				mov edx, balls
				mov ecx, [edx + ecx]
				sub ecx, xn
				imul eax, ecx
				mov edx, k
				imul edx, 18h
				mov ecx, balls
				mov edx, [ecx + edx + 4]
				sub edx, yn
				mov ecx, k
				imul ecx, 18h
				mov esi, balls
				mov ecx, [esi + ecx + 4]
				sub ecx, yn
				imul edx, ecx
				add eax, edx
				
				mov d, eax
				
				.if d == 0
					mov cc, 0FFh
				.else
					mov edx, k
					imul edx, 18h
					mov eax, balls
					mov eax, [eax + edx + 10h]
					xor edx, edx
					div d
					mov cc, eax
					
					.if cc >= 256
						mov cc, 0FFh
					.endif
				.endif
				
				mov ecx, c_
				add ecx, cc
				mov c_, ecx
				
				mov eax, k
				add eax, 1
				mov k, eax
			.endw
			
			;Blue
			mov eax, c_
			xor edx, edx
			div balls_cnt
			and eax, 0FFh   
			mov edx, yn
			imul edx, X_SIZE
			add edx, xn
			mov ecx, b
			mov esi, pal
			mov al, [esi + eax * 4] ; + 2
			mov [ecx + edx * 4], al
			
			;Green
			mov eax, c_
			xor edx, edx
			div balls_cnt
			and eax, 0FFh
			mov ecx, yn
			imul ecx, X_SIZE
			add ecx, xn
			mov edx, b
			mov esi, pal
			mov al, [esi + eax * 4 + 1]
			mov [edx + ecx * 4 + 1], al
			
			; Red
			mov eax, c_
			xor edx, edx
			div balls_cnt
			and eax, 0FFh
			mov ecx, yn
			imul ecx, X_SIZE
			add ecx, xn
			mov edx, b
			mov esi, pal
			mov al, [esi + eax * 4 + 2] ; - 1
			mov [edx + ecx * 4 + 2], al
			
			mov ecx, xn
			add ecx, 1
			mov xn, ecx
		.endw
		
		mov edx, yn
		add edx, 1
		mov yn, edx
	.endw
	
	invoke move_balls
	invoke render_meta

	ret
process_meta endp

;--------------------------------------------------------------------------------

print_text	proc
LOCAL delta: DWORD

	mov esi, szOffset
	invoke lstrlen, esi
	mov ebx, eax
	inc ebx
	m2m delta, DY
	mov edi, esi
@@:
	.if (byte ptr[esi] == 13) || (byte ptr[esi] == 0)
		mov cl, [esi]
		push ecx
		mov byte ptr[esi], 0
		invoke lstrlen, edi
		invoke TextOut, hMemDC, 103, delta, edi, eax
		add delta, 15
		pop ecx
		mov edi, esi
		inc edi
		mov byte ptr[esi], cl
	.endif
	lodsb
	dec ebx
	jnz @B
	mov eax, delta
	sub eax, DY
	shr eax, 1
	ret

print_text	endp

;--------------------------------------------------------------------------------

render_meta	proc
	
	invoke RGB, TxtNewColor, 255, 255
	invoke SetTextColor, hMemDC, eax
	; Print text
	invoke print_text
	; Delay text
	mov ecx, WY/2
	sub ecx, eax
	.if (DY == ecx)
		mov ecx, eax
		shl ecx, 2
		add ecx, 5 ;   
		.if (SD < ecx)
			inc SD
			inc DY
		.else
			mov SD, 0
		.endif
	.endif
	; Scroll text
	cld
	dec DY
	add eax, eax
	not eax
	.if (DY == eax)
		mov edi, szOffset
		xor eax, eax
		or ecx, -1
		repnz scasb
		.if byte ptr[edi]
			mov szOffset, edi
		.else
			m2m szOffset, offset szText
		.endif
		mov DY, WY
	.endif	
	ret
render_meta endp

;--------------------------------------------------------------------------------

DlgProc PROC hWnd :HWND, uMsg :UINT, wParam :WPARAM, lParam :LPARAM
LOCAL ps: PAINTSTRUCT
	
	.if uMsg == WM_INITDIALOG
		invoke init_meta, hWnd
		invoke GetDlgItem, hWnd, 1
		invoke SetFocus, eax
		invoke music_load, hWnd, 100
		invoke music, TRUE

		mov DY, WY
		mov SD, 0
	.elseif uMsg == WM_PAINT
		invoke BeginPaint, hWnd, addr ps
		invoke BitBlt, eax, 0, 0, X_SIZE, Y_SIZE, hMemDC, 0, 0, SRCCOPY
		invoke EndPaint, hWnd, addr ps

	.elseif uMsg == WM_TIMER
		.if wParam == WM_TIMER_DRAW
			invoke process_meta
		.elseif wParam == WM_TIMER_MOVE
			call UpdateWordsColor
		.endif
		invoke InvalidateRect, hWnd, 0, FALSE
		
	.elseif uMsg == WM_RBUTTONUP
		invoke uninit_meta, hWnd
		invoke EndDialog, hWnd, wParam
		
	.elseif uMsg == WM_LBUTTONDOWN
		invoke SendMessage, hWnd, WM_NCLBUTTONDOWN, HTCAPTION, lParam
	
	.elseif uMsg == WM_LBUTTONDBLCLK
		invoke music_pause
		;.if played == TRUE
		;	invoke music, FALSE
		;.else
		;	invoke music, TRUE
		;.endif
		
	.elseif uMsg == WM_CLOSE
		invoke music, FALSE
		invoke PostQuitMessage, NULL
	.endif
	xor eax, eax
	ret
DlgProc endp

;--------------------------------------------------------------------------------

end start